/*
 * CatalogueView.java
 *
 * Created on 10 de agosto de 2004, 17:58
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;
import java.util.Vector;
import java.util.Enumeration;
import java.sql.Date;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.ProductList;
import com.fenalco.entities.SupplierProductList;
import com.fenalco.entities.Store;
import com.fenalco.entities.SupplierList;
import com.fenalco.entities.User;
import com.fenalco.entities.DataAccess;
import com.fenalco.entities.SuperOffer;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.lists.ProductListViewSupplier;

/**
 * 
 * @author andres
 * @version
 */
public class CatalogueView extends HttpServlet
{

	/**
	 * Initializes the servlet.
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destroys the servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Hay que cargar la lista de productos que se le están ofreciendo a este
	 * minorista, además hay que paginar el listado e incluir el motor de
	 * búsqueda
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{

		HttpSession session = request.getSession(false);
		String url = "";
		String message = "";
                Vector messages = new Vector();

	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				message = MessageBuilder.buildMessage(15);
                                
			}
			else
			{
	
				// obtengo el id del establecimiento
				//Store establecimiento = (Store) session.getAttribute("store");
	
				// carga la lista de proveedores para enviarla al jsp
				//SupplierList proveedores = new SupplierList(
				// establecimiento.getId() );
				//SupplierListViewSysManager prov = new SupplierListViewSysManager(
				// proveedores );
	
				// captura los criterios de búsqueda provenientes del jsp
				boolean esNombre = true;
				String nombre = "";
				String categoria = "";
				int orden = 2;
	
				// criterios de paginación
				int pagina = 1;
				int resultadosPagina = 20;
				int paginas; // numero total de páginas
				int inicio = 0; // numero del primero registro que se va a mostrar
				int fin = 19; // numero del último registro que se va a mostrar
				int total; // numero total de resultados
	
				try
				{
					String temp = request.getParameter("esnombre");
					if( temp == null )
					{
						temp = "1";
					}
					//System.out.println("TEMP = " + temp);
					if( Integer.parseInt(temp) == 1 )
					{
						esNombre = true;
					}
					else
					{
						esNombre = false;
					}
	
					temp = request.getParameter("nombre");
					if( temp == null )
					{
						nombre = "";
					}
					else
					{
						nombre = temp;
					}
	
					temp = request.getParameter("categoria");
					if( temp == null )
					{
						categoria = "";
					}
					else
					{
						categoria = temp;
					}
					temp = request.getParameter("ordenamiento");
					if( temp == null )
					{
						orden = 2;
					}
					else
					{
						orden = Integer.parseInt(temp);
					}
					temp = request.getParameter("page");
					if( temp == null )
					{
						pagina = 1;
					}
					else
					{
						pagina = Integer.parseInt(temp);
					}
					pagina = (pagina < 1) ? 1 : pagina;
					temp = request.getParameter("pageResults");
					if( temp == null )
					{
						resultadosPagina = 20;
					}
					else
					{
						resultadosPagina = Integer.parseInt(temp);
					}
					resultadosPagina = (resultadosPagina < 1) ? 20
							: resultadosPagina;
	
				}
				catch (Exception e)
				{
					System.out.println("Excepcion en el servlet del catalogo --> "+ e);
				}
	
				User user = (User) session.getAttribute("user");
				//int emprId = user.getCompanyId();
				int proveedor = user.getCompanyId();
				SupplierList proveedores = new SupplierList();
	
				ProductList lista = new ProductList();
	
				// hago la búsqueda y obtengo solo los ids de los productos que
				// cumplen
				// los criterios seleccionados
                                Vector ids;
                                if( request.getParameter("superOffer") != null ){
                                    
                                    SuperOffer superOffer = ( SuperOffer )session.getAttribute("superOffer");
                                    try{
                                        
                                        String startDate = request.getParameter( "startDate" );
                                        String endDate = request.getParameter( "endDate" );
                                        String description = request.getParameter( "description" );
                                        int stock = Integer.parseInt( request.getParameter( "stock" ) );
                                        
                                        superOffer.setStartDate( Date.valueOf( startDate ) );
                                        superOffer.setEndDate(Date.valueOf( endDate ) );
                                        superOffer.setDescription( description );
                                        superOffer.setStock( stock );
                                        
                                        session.setAttribute( "superOffer", superOffer );
                                        
                                        
                                    }catch( Exception e ){
                                    
                                        session.removeAttribute( "superOffer" );
                                        System.out.println( "Borrando Sesión de SuperOferta Catálogo" );
                                        
                                    }
                                
                                    ids = lista.loadActiveIds(esNombre, nombre, proveedor, categoria,
						orden, proveedores, true);
                                    
                                }else{
                                    
                                    ids = lista.loadIds(esNombre, nombre, proveedor, categoria,
						orden, proveedores, true);
                                }
				
                                int numActive = SupplierProductList.getNumStatusProducts( proveedor, 1 );
                                int numInactive = SupplierProductList.getNumStatusProducts( proveedor, 0 );
	
				// aqui se efectua la paginación
				total = ids.size();
				paginas = (int) Math.ceil((double) total
						/ (double) resultadosPagina);
				if( pagina > paginas )
				{
					pagina = paginas;
				}
				inicio = (pagina - 1) * resultadosPagina;
				fin = pagina * resultadosPagina;
				inicio = (inicio < 0) ? 0 : inicio;
				if( fin > total )
				{
					fin = total;
				}
				for( int i = inicio; i < fin; i++ )
				{
					//System.out.println("Buscando elemento " + i);
					lista.addElement(ids.elementAt(i));
				}
	
				ProductListViewSupplier vistaCatalogo;
	
				vistaCatalogo = new ProductListViewSupplier(lista);
	
				//message = (String) request.getAttribute("message");
                                //RECEPCION DEL MENSAJE
                                if( request.getAttribute( "message" ) != null ){
                                
                                    Enumeration en = ((Vector)request.getAttribute( "message" )).elements();
                                    while( en.hasMoreElements() ){
                                        messages.add( (String)en.nextElement() );                                    
                                    }
                                    
                                }
                                
                                
	
				//request.setAttribute( "proveedores", prov );
				request.setAttribute("productos", vistaCatalogo);
                                request.setAttribute("categorias", DataAccess.getSupplierCategories( proveedor ) );
                                
	
				// información de los criterios de búsqueda
				request.setAttribute("esNombre", Boolean.valueOf(esNombre));
				request.setAttribute("nombre", nombre);
				
				request.setAttribute("categoria", categoria);
				request.setAttribute("ordenamiento", Integer.valueOf(orden + ""));
	
				/// información de la paginacion
				inicio++; // para no arrancar desde 0
				inicio = (fin == 0) ? 0 : inicio;
				request.setAttribute("firstRow", inicio + "");
				request.setAttribute("lastRow", fin + "");
				request.setAttribute("total", total + "");
				request.setAttribute("page", pagina + "");
				request.setAttribute("pages", paginas + "");
				request.setAttribute("pageResults", resultadosPagina + "");
                                
                                request.setAttribute( "numActive", new Integer( numActive ) );
                                request.setAttribute( "numInactive", new Integer( numInactive ) );
                                
                                
                                if( messages.size() == 0 ){
                                    
                                    messages.add("");
                                    
                                }
                                
                                request.setAttribute("messages", messages);
				
	
				if( request.getParameter("superOffer") != null )
				{
					url = "/proveedor/catalogosuperofertas.jsp";
					request.setAttribute("superOfferId", new Integer( request.getParameter( "superOfferId" ) ) );
				}
				else
				{
					url = "/proveedor/catalogoproveedor.jsp";
				}
	
			}
	    }
	    catch( Exception e )
	    {
                e.printStackTrace();
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
                //message.add( MessageBuilder.buildMessage(15) );
	    }

		request.setAttribute("message", message);
		RequestDispatcher rd = getServletContext().getRequestDispatcher(url);
		rd.forward(request, response);
	}

	/**
	 * Handles the HTTP <code>GET</code> method.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Handles the HTTP <code>POST</code> method.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Returns a short description of the servlet.
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}